var version="1.0";
var version_re= /version=(.+?)$/;
var eyeTVWebsites=new Array("www.titantv.com","www.tvtv.at", "www.tvtv.nl", "www.tvtv.fr", "www.tvtv.de", "www.tvtv.it", "www.tvtv.es", "www.tvtv.ch", "www.tvtv.co.uk");
var eyeTVWebsitesNames=new Array("TitanTV","tvtv.at", "tvtv.nl", "tvtv.fr", "tvtv.de", "tvtv.it", "tvtv.es", "tvtv.ch", "tvtv.co.uk");
var eyeTVChannelsList=new Array();
var eyeTVRecordList=new Array();
var currentEyeTVId;
var currentEyeTVName;
var currentEyeMovieId;
var currentEyeMovieName;
var eyeTVCmdRunning=false;
var eyeTVChannelsChecked=false;
var isEyeTVDetected=false;
var saveEyeTVLinks="";
var eyeTVRemote=false;
var eyeTVRemoteAddress="Host";
var eyeTVRemoteUser="Login";
var eyeTVRemotePassword="Password";
var currentPanel="main";
var timer;
var needToRefreshEyeTV=false;
var eyeTVMode="tv";
var hasMarquee=false;
var isGettingEyeTVMovies=false;
var eyeTVError="";

var preferedWebsite="";

var getStatusCmd="set isRecording to false\ntry\nset starttime to start time of last program\nset isRecording to (((duration of last program) is equal to 1.08E+4) or ((starttime + ((duration of last program) / 60) * minutes) > (current date)))\nend try\nreturn (get playing as string) & \"*\" & (isRecording as string) & \"*\" & (get current channel) & \"*\" & (get name of channel (get current channel))";
var closeAllPlayersCmd="if (full screen) then\n set full screen to false\nend\nrepeat while ((count of player_windows) > 1)\nset player to player_window 1\nselect player\nclose player\nend repeat\ntry\nclose player_window 1\nend try";

function getPrograms() {
	if (preferedWebsite!="") {
 		clicked('http://'+preferedWebsite);
 	} else {
 		showEyeTVProgram(window);
 	}
}

function init_remote() {
	checkVersion();
	widget.onshow = show;
	widget.onhide = hide;
		
	if (widget.preferenceForKey(createkey("eyeTVRemote"))) {
		eyeTVRemote=widget.preferenceForKey(createkey("eyeTVRemote"));
	}
	
	if (widget.preferenceForKey(createkey("eyeTVRemoteAddress"))) {
		eyeTVRemoteAddress=widget.preferenceForKey(createkey("eyeTVRemoteAddress"));
	}
	
	if (widget.preferenceForKey(createkey("eyeTVRemoteUser"))) {
		eyeTVRemoteUser=widget.preferenceForKey(createkey("eyeTVRemoteUser"));
	}
	
	if (widget.preferenceForKey(createkey("eyeTVRemotePassword"))) {
		eyeTVRemotePassword=widget.preferenceForKey(createkey("eyeTVRemotePassword"));
	}
	if (widget.preferenceForKey(createkey("preferedWebsite"))) {
		preferedWebsite=widget.preferenceForKey(createkey("preferedWebsite"));
	}
	
	if (preferedWebsite=="") {
		if (defaultListingSite!="") {
			preferedWebsite=defaultListingSite;
		} else {
			preferedWebsite="www.titantv.com";
		}
	}
	
	saveEyeTVLinks=widget.preferenceForKey(createkey("saveEyeTVLinks"));
	if (saveEyeTVLinks) {
		initEyeTVChannelsFromPreferences();
		eyeTVChannelsChecked=true;
		isEyeTVDetected=true;
		//document.getElementById("eyeTVlogo").style.display="block";
	}
	
	var listingList=document.getElementById("listingSelect");
	var option=""
	for (var i=0;i<eyeTVWebsites.length;i++) {
		option="";
		if (eyeTVWebsites[i]==preferedWebsite) option=" selected";
		listingList.innerHTML+="<option value='"+eyeTVWebsites[i]+"'"+option+">"+eyeTVWebsitesNames[i];
	}
	updateValuesOfPreferences();
	eyeTVCmdRunning=false;
	getEyeTVChannels() ;
	if (eyeTVError=="") {
		checkStatus();
	} else {
		//TRACE("init error => "+eyeTVError);
	}
	initLanguages();
}

function updateValuesFromPreferences() {
	var eyeTVRemoteOld=eyeTVRemote;
	eyeTVRemote=document.getElementById("EyeTVRemoteBox").checked;
	var eyeTVRemoteAdressOld=eyeTVRemoteAddress;
	eyeTVRemoteAddress=document.getElementById("EyeTVRemoteAdress").value;
	var eyeTVRemoteUserOld=eyeTVRemoteUser;
	eyeTVRemoteUser=document.getElementById("EyeTVRemoteUser").value;
	var eyeTVRemotePasswordOld=eyeTVRemotePassword;
	eyeTVRemotePassword=document.getElementById("EyeTVRemotePassword").value;
	
	if (eyeTVRemote!=eyeTVRemoteOld
		|| eyeTVRemoteAddress!=eyeTVRemoteAdressOld
		|| eyeTVRemoteUser!=eyeTVRemoteUserOld
		|| eyeTVRemotePassword!=eyeTVRemotePasswordOld) needToRefreshEyeTV=true;
	else needToRefreshEyeTV=false;
}

function refreshEyeTV() {
	if (needToRefreshEyeTV==true) {
		eyeTVMode="tv";
		eyeTVChannelsChecked=false;
		getEyeTVChannels();
		if (eyeTVError=="") {
			checkStatus();
		}
	}
}

function updateValuesOfPreferences() {
	document.getElementById("EyeTVRemoteBox").checked=eyeTVRemote;
	document.getElementById("EyeTVRemoteAdress").value=eyeTVRemoteAddress;
	document.getElementById("EyeTVRemoteUser").value=eyeTVRemoteUser;
	document.getElementById("EyeTVRemotePassword").value=eyeTVRemotePassword;
}

function saveSettings() {
	updateValuesFromPreferences();
	widget.setPreferenceForKey(eyeTVRemote,createkey("eyeTVRemote"));
	widget.setPreferenceForKey(eyeTVRemoteAddress,createkey("eyeTVRemoteAddress"));
	widget.setPreferenceForKey(eyeTVRemoteUser,createkey("eyeTVRemoteUser"));
	widget.setPreferenceForKey(eyeTVRemotePassword,createkey("eyeTVRemotePassword"));
	widget.setPreferenceForKey(preferedWebsite,createkey("preferedWebsite"));
}

function updateWebSiteSelection() {
	var listingList=document.getElementById("listingSelect");
	preferedWebsite=listingList.options[listingList.selectedIndex].value;
}

function newChaine () {
	return {eyetvname:"", eyetv:"", uniqueID:""};
}

function switchEyeTVFullScreenSize(doc) {
	execSimpleEyeTVCmd(doc,"set full screen to not (get full screen)");
}

function increaseEyeTVSound(doc) {
	execSimpleEyeTVCmd(doc,"volume_up\nvolume_up");
}

function decreaseEyeTVSound(doc) {
	execSimpleEyeTVCmd(doc,"volume_down\nvolume_down");
}

function increaseEyeTVChannel(doc) {
	if (eyeTVMode=="tv") {
		execSimpleEyeTVCmd(doc,"channel_up\n"+getStatusCmd, endCheckStatus);
	} else {
		execSimpleEyeTVCmd(doc,"skip forward\n"+getStatusCmd, endCheckStatus);
	}
}

function decreaseEyeTVChannel(doc) {
	if (eyeTVMode=="tv") {
		execSimpleEyeTVCmd(doc,"channel_down\n"+getStatusCmd, endCheckStatus);
	} else {
		execSimpleEyeTVCmd(doc,"skip backward\n"+getStatusCmd, endCheckStatus);
	}
}

function muteEyeTV(doc) {
	execSimpleEyeTVCmd(doc,"mute");
}

function playpauseEyeTV(doc) {
	if (eyeTVMode=="tv") {
		execSimpleEyeTVCmd(doc,"if (get playing) then\npause\nelse\nplay\nend if\n"+getStatusCmd, endStartStop);
	} else {
		var liste=document.getElementById("eyetv_channels");
		var id=liste.selectedIndex+1;
		execSimpleEyeTVCmd(doc,"if (get playing) then\npause\nelse\nplay recording "+id+"\nplay\nend if\n"+getStatusCmd, endStartStop);
	}
}

function startstopRecordEyeTV(doc) {
	execSimpleEyeTVCmd(doc,"set isRecording to false\ntry\nset starttime to start time of last program\nset isRecording to (((duration of last program) is equal to 1.08E+4) or ((starttime + ((duration of last program) / 60) * minutes) > (current date)))\nend try\nif (isRecording) then\nstop recording\nelse\nstart recording\nend if\n"+getStatusCmd, endStartStop);
}

function showHideEyeTVWindow(doc) {
	execSimpleEyeTVCmd(doc,"showhide application");
}

function showHideEyeTVControler(doc) {
	execSimpleEyeTVCmd(doc,"showhide controller_window");
}

function showHideEyeTVProgram(doc) {
	execSimpleEyeTVCmd(doc,"showhide programs_window");
}

function showEyeTVProgram(doc) {
	execSimpleEyeTVCmd(doc,"show programs_window");
}

function getEyeTVStatus(doc, fonc) {
	//TRACE("getEyeTVStatus");
	execSimpleEyeTVCmd(doc, getStatusCmd, fonc);
}

function changeEyeTVChannel(doc, id, fonc) {
	execSimpleEyeTVCmd(doc, "set current channel to "+id, fonc);
}

function changeEyeTVMovie(doc, id, fonc) {
	//TRACE("changeEyeTVMovie");
	//TRACE(closeAllPlayersCmd+"\nplay recording "+id);
	execSimpleEyeTVCmd(doc, "set isFullScreen to full screen\n"+closeAllPlayersCmd+"\nplay recording "+id+"\nif (isFullScreen) then enter full screen", fonc);
}

function execSimpleEyeTVCmd(doc, code, fct) {
	if (fct==null) fct=endSimpleEyeTVCmd;
	//TRACE("eyeTVCmdRunning: "+eyeTVCmdRunning);
	if (eyeTVCmdRunning==true) return;
	eyeTVCmdRunning=true;
	pleaseWaitEyeTV();
	
	if (doc.eyeTVRemote) {
		commande="/usr/bin/osascript -e 'tell application \"EyeTV\" of machine \"eppc://"+doc.eyeTVRemoteUser+":"+doc.eyeTVRemotePassword+"@"+doc.eyeTVRemoteAddress+"\"\nusing terms from application \"EyeTV\"\n"+code+"\nend using terms from\nend tell'";
	} else {
		commande="/usr/bin/osascript -e 'tell application \"EyeTV\"\n"+code+"\nend tell'";
	}
	doc.widget.system(commande,fct);
}

function endSimpleEyeTVCmd(cmd) {
	eyeTVCmdRunning=false;
	if (eyeTVMode=="tv") {
		buildEyeTVChannelList();
	} else {
		buildEyeTVRecordsList();
	}
}

function endStartStop(cmd) {
	endCheckStatus(cmd);
}

function checkStatus() {
	if (eyeTVError=="")
		getEyeTVStatus(parent, endCheckStatus);
}

function endCheckStatus(cmd) {
	eyeTVCmdRunning=false;
	var result_re=/(.+)\*(.+)\*(.+)\*(.+)/; 
	var out=cmd.outputString;
	var playing=false;
	var recording=false;

	if (out) {
		out=out.split("\n")[0];
		if (result_re.test(out)) {
			result_re.exec(out);
			playing=(RegExp.$1=="true");
			recording=(RegExp.$2=="true");
			//TRACE("recording: "+recording);
			currentEyeTVId=RegExp.$3;
			currentEyeTVName=RegExp.$4;
		}
	}
	var img=document.getElementById("eyeTVplayingImg");
	if (playing) {
		img.style.display="block";
	} else {
		img.style.display="none";
	}
	img=document.getElementById("eyeTVrecordImg");
	
	//TRACE("recording: "+recording);
	if (recording) {
		img.style.display="block";
	} else {
		img.style.display="none";
	}
	
	//TRACE("endCheckStatus - eyeTVMode: "+eyeTVMode);
	if (eyeTVMode=="tv") {
		buildEyeTVChannelList();
	} else {
		//TRACE("buildEyeTVRecordsList");
		buildEyeTVRecordsList();
	}
}

function pleaseWaitEyeTV() {
	document.getElementById("eyeTVStatus").innerHTML="Please wait";
	document.getElementById("eyetv_channels").innerHTML="";
}

function updateEyeTVStatus(val1, val2) {
	if (val2!=null) {
		document.getElementById("eyeTVStatus").innerHTML="<b>"+val1+"<br><font class='littleStatus'>"+val2+"</font></b>";
	} else {
		if (val1!=null) {
			if (val1.length>24) {
				document.getElementById("eyeTVStatus").innerHTML="<marquee scrolldelay='200'><b><font class='littleStatus'>"+val1+"</font></b></marquee>";
			} else {
				document.getElementById("eyeTVStatus").innerHTML="<b><font class='littleStatus'>"+val1+"</font></b>";
			}
		}
	}
}

function buildEyeTVChannelList() {
	if (eyeTVChannelsList!=null && eyeTVChannelsList.height==0) {
		updateEyeTVStatus(getLocalizedString('noList'));
	} else {
		updateEyeTVStatus(currentEyeTVId,currentEyeTVName);
	}
	var tmpChannel;
	var selected="";
	//TRACE("buildEyeTVChannelList: "+eyeTVChannelsList.length);
	document.getElementById("eyetv_channels").innerHTML="";
	for (var i=0;i<eyeTVChannelsList.length;i++) {
		tmpChannel=eyeTVChannelsList[i];
		selected="";
		if (tmpChannel.eyetvname==currentEyeTVName) {
			selected=" selected";
		}
		document.getElementById("eyetv_channels").innerHTML+="<option value='"+tmpChannel.uniqueID+"'"+selected+">"+tmpChannel.eyetv+" "+tmpChannel.eyetvname+"</option>";
	}
}

function popupTV_eyetv_channelsListChanged(elem) {
	if (eyeTVMode=="tv") {
		var chosenOption = elem.options[elem.selectedIndex].value;
		var chosenText = elem.options[elem.selectedIndex].text;
		var channel_re=/(\d+) (.+)/;
		if (channel_re.test(chosenText)) {
			channel_re.exec(chosenText);
			currentEyeTVId=RegExp.$1;
			currentEyeTVName=RegExp.$2;
		}
		changeEyeTVChannel(parent,chosenOption, endChangeChannelEyeTVCmd);
	} else {
		var chosenOption = elem.options[elem.selectedIndex].value;
		var chosenText = elem.options[elem.selectedIndex].text;
		currentEyeMovieId=chosenOption;
		currentEyeMovieName=chosenText;
		changeEyeTVMovie(parent,""+(elem.selectedIndex+1), endChangeChannelEyeMovieCmd );
	}
}

function endChangeChannelEyeMovieCmd(cmd) {
	eyeTVCmdRunning=false;
	//TRACE("endChangeChannelEyeMovieCmd - eyeTVCmdRunning: "+eyeTVCmdRunning);
	checkStatus();
	buildEyeTVRecordsList();
}

function endChangeChannelEyeTVCmd(cmd) {
	eyeTVCmdRunning=false;
	buildEyeTVChannelList();
}

function initEyeTVChannelsFromPreferences() {
	var links=saveEyeTVLinks.split("\n");
	var link_re=/(.+?)~(.+?)$/;
	var link;
	var tmpChannel;
	eyeTVChannelsList.clear();
	for (var i=0;i<links.length;i++) {
		link=links[i];
		if (link_re.test(link)) {
			link_re.exec(link);
			tmpChannel=newChaine();
			tmpChannel.eyetv=RegExp.$1;
			tmpChannel.eyetvname=RegExp.$2;
			tmpChannel.uniqueID=tmpChannel.eyetv;
			eyeTVChannelsList.push(tmpChannel);
		}
	}
}

function initLanguages()
{
	document.getElementById('recording').title = getLocalizedString('record');
	document.getElementById('play').title = getLocalizedString('play');
	document.getElementById('fullscreen').title = getLocalizedString('fullscreen');
	document.getElementById('listing').title = getLocalizedString('planning');
	document.getElementById('eyetv_channels').title = getLocalizedString('liste');
	document.getElementById('next').title = getLocalizedString('nextchannel');
	document.getElementById('previous').title = getLocalizedString('previouschannel');
	document.getElementById('mute').title = getLocalizedString('mute');
	document.getElementById('levelup').title = getLocalizedString('uplevel');
	document.getElementById('leveldown').title = getLocalizedString('downlevel');
	document.getElementById('controller').title = getLocalizedString('controller');
	
	document.getElementById('elgato').title = getLocalizedString('elgato');
	document.getElementById('EyeTVRemoteBox').title = getLocalizedString('EyeTVRemoteBox');
	document.getElementById('EyeTVRemoteAdress').title = getLocalizedString('EyeTVRemoteAdress');
	document.getElementById('EyeTVRemoteUser').title = getLocalizedString('EyeTVRemoteUser');
	document.getElementById('EyeTVRemotePassword').title = getLocalizedString('EyeTVRemotePassword');
	document.getElementById('listingSelect').title = getLocalizedString('listingSelect');
}

/************************
* initEyeTVChannels: Init EyeTV channels by calling EyeTV
************************/
function getEyeTVChannels() {
	if (eyeTVChannelsChecked) return;
	eyeTVChannelsChecked=true;
	if (testEyeTV()==false) {
		//TRACE("Erreur EyeTV");
		updateEyeTVStatus(eyeTVError);
		return false;
	}
	pleaseWaitEyeTV();
	isEyeTVDetected=true;
	eyeTVChannelsList.clear();
	var endOfChannels=false;
	var script="";
	var id=1;
	var cmd;
	var name="";
	var channel;
	var nbError=0;
	saveEyeTVLinks="";
	var optionRemote="";
		if (eyeTVRemote) {
		optionRemote=" of machine \"eppc://"+eyeTVRemoteUser+":"+eyeTVRemotePassword+"@"+eyeTVRemoteAddress+"\" ";
	}
	
	var myscript="tell application \"EyeTV\""+optionRemote+"\n"+closeAllPlayersCmd+"\nset message to \"\"\nrepeat with chaine in channels\nset message to message & (channel number of chaine) & \":\" & (name of chaine) & \"|\"\nend repeat\nget message\nend tell";
		
				
	var myCmd="";
	if (eyeTVRemote) 
		myCmd="/usr/bin/osascript -e '"+myscript+"'";
	else
		myCmd="/usr/bin/osascript -e 'tell application \"Finder\""+optionRemote+"\nif process \"EyeTV\" exists then\n"+myscript+"\nelse\n "+myscript+"\nset visible of process \"EyeTV\" to false\nend if\nend tell'";
	
	//if (debugEyeTVChannelCall) TRACE(myCmd);
	cmd=widget.system(myCmd, null);
	//TRACE(cmd.errorString);
	var maliste=cmd.outputString;
	if (maliste && maliste.length>1) maliste=maliste.substring(0,maliste.length-1);
	//TRACE("maliste: "+maliste);
	if (maliste) {
		var tabChaines=maliste.split("|");
		var eyeTVDesc_re=/(\d+):(.+)/;
		var line;
		for (var indice=0;indice<tabChaines.length;indice++) {
			line=tabChaines[indice];
			channel=null;
			if (eyeTVDesc_re.test(line)) {
				eyeTVDesc_re.exec(line);
				channel=newChaine();
				channel.eyetv=RegExp.$1;
				channel.eyetvname=RegExp.$2;
				channel.uniqueID=channel.eyetv;
				eyeTVChannelsList.push(channel);
				saveEyeTVLinks+=channel.eyetv+"~"+channel.eyetvname+"\n";
				if (channel==null) {
					if (debugEyeTVChannelCall) TRACE("eyetv: "+name+" at "+id+" not found in WidgetCineTV");
				}
			}
		}
	}
	widget.setPreferenceForKey(saveEyeTVLinks, createkey("saveEyeTVLinks"));
}

function getMoviesList() {
	pleaseWaitEyeTV();
	if (isGettingEyeTVMovies==true) {
		if (eyeTVRecordList!=null && eyeTVRecordList.length==0) {
			updateEyeTVStatus(getLocalizedString('noList'));
		}	
		return;
	}
	isGettingEyeTVMovies=true;
	eyeTVRecordList.clear();
	var script="";
	var id=1;
	var cmd;
	var name="";
	var channel;
	var nbError=0;
	
	var optionRemote="";
		if (eyeTVRemote) {
		optionRemote=" of machine \"eppc://"+eyeTVRemoteUser+":"+eyeTVRemotePassword+"@"+eyeTVRemoteAddress+"\" ";
	}
	
	var myscript="tell application \"EyeTV\""+optionRemote+"\nset message to \"\"\nset indice to 1\ntry\nrepeat with programme in recordings\nset message to message & indice & \"~\" & (unique ID of programme) & \"~\" & (title of programme) & \" - \" & (episode of programme)  & \"|\"\nset indice to indice + 1\nend repeat\nend try\nget message\nend tell";

				
	var myCmd="";
	if (eyeTVRemote) 
		myCmd="/usr/bin/osascript -e '"+myscript+"'";
	else
		myCmd="/usr/bin/osascript -e 'tell application \"Finder\""+optionRemote+"\nif process \"EyeTV\" exists then\n"+myscript+"\nelse\n "+myscript+"\nset visible of process \"EyeTV\" to false\nend if\nend tell'";
	
	//TRACE(myCmd);
	cmd=widget.system(myCmd, null);
	var maliste=cmd.outputString;
	
	//var maliste="1~1,58652331E+8~Chevaliers du zodiac (anciens)-25|2~1,58652332E+8~Chevaliers du zodiac (anciens)-29|3~1,58652333E+8~Chevaliers du zodiac (anciens)-|4~1,58652334E+8~Chevaliers du zodiac (anciens)-|5~1,58652335E+8~Chevaliers du zodiac (anciens)-|6~1,58652336E+8~Chevaliers du zodiac (anciens)-|7~1,58652337E+8~Chevaliers du zodiac (anciens)-|8~1,58652338E+8~Chevaliers du zodiac (anciens)-|9~1,5865233E+8~Chevaliers du Zodiac-92|10~1,58652328E+8~Chevaliers du Zodiac-90|11~1,58652329E+8~Chevaliers du Zodiac-91|12~1,67086041E+8~Essais-pub|13~1,68814074E+8~Gold Digger-Kanye West|14~1,69110349E+8~Hit Music Only-Clips|15~1,68815134E+8~Je Pense  Toi-Saya|16~1,67916247E+8~Kaamelott-01-Le Chevalier Errant|17~1,6791765E+8~Kaamelott-10-Le Flau de Dieu II|18~1,68293105E+8~Kaamelott-100-La Dispute 2e partie|19~1,67917801E+8~Kaamelott-11-Le Tournoi|20~1,67917883E+8~Kaamelott-12-La Potion de Vivacit"
	
	if (maliste && maliste.length>1) maliste=maliste.substring(0,maliste.length-1);
	if (maliste) {
		var tabChaines=maliste.split("|");
		var eyeTVDesc_re=/(\d+)~(.+)~(.+)/;
		var line;
		for (var indice=0;indice<tabChaines.length;indice++) {
			line=tabChaines[indice];
			channel=null;
			if (eyeTVDesc_re.test(line)) {
				eyeTVDesc_re.exec(line);
				channel=newChaine();
				channel.eyetv=RegExp.$1;
				channel.eyetvname=RegExp.$3;
				channel.uniqueID=RegExp.$2;
				eyeTVRecordList.push(channel);
			}
		}
		if (buildEyeTVRecordsList()==true) {
			isGettingEyeTVMovies=false;
			if (eyeTVRecordList!=null && eyeTVRecordList.length==0) {
				updateEyeTVStatus(getLocalizedString('noList'));
			} else {
				updateEyeTVStatus(currentEyeMovieName);
			}
		}
	}
}

/************************
* testEyeTV: Test if EyeTV exists
************************/
function testEyeTV() {
	pleaseWaitEyeTV();
	//return false;
	if (eyeTVRemote) {
		var optionRemote=" of machine \"eppc://"+eyeTVRemoteUser+":"+eyeTVRemotePassword+"@"+eyeTVRemoteAddress+"\" ";
		
		var applicationNotRunning_re=/Application isn't running./;
		var applicationUserIdentification_re=/Unable to authenticate user./;
		var applicationRemoteNotAllow_re=/Remote access isn't allowed./;
		
		var commande="/usr/bin/osascript -e 'set eyetvpath to path to (application \"EyeTV\""+optionRemote+") as string\n";
		commande+="return POSIX path of eyetvpath'";
		//TRACE("testEyeTV: "+commande);
		var cmd=widget.system(commande,null);
		if (cmd.errorString) {
			if (applicationNotRunning_re.test(cmd.errorString)) {
				eyeTVError= getLocalizedString("remoteEyeTV");
			} else if (applicationUserIdentification_re.test(cmd.errorString)) {
				eyeTVError= getLocalizedString("remoteUser");
			} else if (applicationRemoteNotAllow_re.test(cmd.errorString)) {
				eyeTVError= getLocalizedString("remoteAppleEvents");
			} else {
				eyeTVError=cmd.errorString;
			}
			return false;
		}
		
		//TRACE("Fin testEyeTV");
		if (cmd.outputString) {
			eyeTVError="";
			return true;
		}
		
		
		return false;
	}
	if (window.widget) {
		var optionRemote="";
		
		//var commande="/usr/bin/locate EyeTV.app/Contents/MacOS/EyeTV";
		var commande="/usr/bin/osascript -e 'set eyetvpath to path to (application \"EyeTV\") as string\n";
		commande+="return POSIX path of eyetvpath'";

		var cmd=widget.system(commande,null);
		if (cmd.errorString) {
			eyeTVError=getLocalizedString("noEyeTV");
			return false;
		}
		if (cmd.outputString) {
			eyeTVError="";
			return true;
		}
	}
	return false;
}

function buildEyeTVRecordsList() {
	if (eyeTVRecordList.length==0) {
		getMoviesList();
		return false;
	}
	var tmpChannel;
	var selected="";
	document.getElementById("eyetv_channels").innerHTML="";
	if (currentEyeMovieId!=null) {
		updateEyeTVStatus(currentEyeMovieName);
	}
	for (var i=0;i<eyeTVRecordList.length;i++) {
		tmpChannel=eyeTVRecordList[i];
		selected="";
		if (currentEyeMovieId==null) {
			currentEyeMovieId=tmpChannel.uniqueID;
			currentEyeMovieName=tmpChannel.eyetvname;
		}
		if (tmpChannel.uniqueID==currentEyeMovieId) {
			selected=" selected";
		}
		document.getElementById("eyetv_channels").innerHTML+="<option value='"+tmpChannel.uniqueID+"'"+selected+">"+tmpChannel.eyetvname+"</option>";
	}
	return true;
}

function switchEyeTVMode() {
	pleaseWaitEyeTV();
	if (eyeTVMode=="tv") {
		eyeTVMode="movie";
	} else {
		eyeTVMode="tv";
	}
	execSimpleEyeTVCmd(window,closeAllPlayersCmd, endCloseAllPlayers);
	
	//TRACE("eyeTVMode: "+eyeTVMode);
	document.getElementById("eyeTVModeImg").src="EyeTV/"+eyeTVMode+".png";
	if (eyeTVMode=="tv") {
		document.getElementById("eyeTVaccelerate").style.display="none";
		document.getElementById("eyeTVback").style.display="none";
		document.getElementById('next').title = getLocalizedString('nextchannel');
		document.getElementById('previous').title = getLocalizedString('previouschannel');
		document.getElementById('eyetv_channels').title = getLocalizedString('liste');
		buildEyeTVChannelList();
	} else {
		document.getElementById("eyeTVaccelerate").style.display="block";
		document.getElementById("eyeTVback").style.display="block";
		document.getElementById('next').title = getLocalizedString('accelerate');
		document.getElementById('previous').title = getLocalizedString('back');
		document.getElementById('eyetv_channels').title = getLocalizedString('listeMovies');
		if (buildEyeTVRecordsList()==true) {
			//updateEyeTVStatus(currentEyeMovieName);
		}
	} 
}

function endCloseAllPlayers(cmd) {
	eyeTVCmdRunning=false;
	checkStatus();
}

function checkVersion() {
	page = readDOM("http://ismileys.free.fr/eyeControl/version.txt", false);
	if (page!=null) {
		lines=page.split("\n");
		for( var i = 0; i < lines.length; i=i+1){
			line=lines[i];
			if (version_re.test(line)) {
				version_re.exec(line);
				online_version=RegExp.$1;
				if (version<online_version) {
					document.getElementById("updateversion").innerHTML="<marquee scrolldelay='200'>New version 2 available !!! Click here to download.</marquee>";
				} else {
					document.getElementById("updateversion").innerHTML="v"+version;
				}
			}
		}
	} else {
		document.getElementById("updateversion").innerHTML="<a title=\"Ouvrir le site iSmileys\" href=\"#\" onclick=\"clicked('http://ismileys.free.fr/widgettv');return false;\" class=\"link\">Widget CineTV "+version+"</a>";
	}
}

function hide() {
	hasMarquee=false;
	var elem=document.getElementById("eyeTVStatus");
	var status=elem.innerHTML;
	var testMarquee_re=/<MARQUEE [^>]*>(.*)<\/MARQUEE>/;
	if (testMarquee_re.test(status)) {
		testMarquee_re.exec(status);
		hasMarquee=true;
		elem.innerHTML=RegExp.$1;
	}
	document.getElementById("updateversion").style.display="none";
	
}

function show() {
	document.getElementById("updateversion").style.display="block";
	if (hasMarquee==true) {
		var elem=document.getElementById("eyeTVStatus");
		elem.innerHTML="<marquee scrolldelay='200'>"+elem.innerHTML+"</marquee>";
	}
	checkVersion();
	checkStatus();
}

function endEyeTVCall(cmd) {
	if (cmd.errorString) {
		TRACE("Error: "+cmd.errorString)
	}
}
